#include "myrt.h"

void ZeroMemory(void* ptr, DWORD size)
{
	while(size--)
		*(((char*)ptr)++) = 0;

	return;
}


VOID strcopy(LPSTR dst, LPCSTR src)
{
	while(*src)	*dst++ = *src++;
	*dst = *src;	// copy null

	return;
}

DWORD strlength(LPCSTR src)
{
	DWORD result = 0;

	while(*src++)	result++;

	return result;
}

int strcomp(const char* p, const char *q)
{
	if(!p || !q)	return 0;
	if(p == q)		return 0;

	for(; *p == *q && *p != '\0'; p++, q++);

	return *p - *q;
}

void strplus(char* p, const char *c)
{
	if(!p || !c || p == c)	return;

	p += strlength(p);	// NULLO܂Ő
	strcopy(p, c);		// strcopyB

	return;
}

void* halloc(DWORD size)
{
	return HeapAlloc(GetProcessHeap(), 0, size);
}

void hfree(void* ptr)
{
	if(ptr)	HeapFree(GetProcessHeap(), 0, ptr);

	return;
}

void* hrealloc(void* ptr, DWORD size)
{
	if(ptr)
		return HeapReAlloc(GetProcessHeap(), 0, ptr, size);
	else
		return halloc(size);
}

VOID strncopy(LPSTR dst, LPCSTR src, DWORD size)
{
	while(*src && size--)
		*dst++ = *src++;

	return;
}

VOID strnncopy(LPSTR dst, LPCSTR src, DWORD size)
{
	while(*src && size--)
		*dst++ = *src++;
	if(!*src)
		*dst = *src;

	return;
}
